diff --git a/vhdlparser/vhdlstring.h b/vhdlparser/vhdlstring.h
index fde6ce4..69c7220 100644
--- a/vhdlparser/vhdlstring.h
+++ b/vhdlparser/vhdlstring.h
@@ -1,14 +1,23 @@
-#ifndef VHDLSTRING_H
-#define VHDLSTRING_H
 
-#include <stdio.h>
+
+
+
+/**
+ *  @brief Minimal string class with std::string like behaviour that fulfills the JavaCC
+ *  string requirements. Added wchar_t for unicode strings.
+ */
+
+#ifndef VHDLSTRING
+#define  VHDLSTRING
+
+
+#include <locale>
 #include <stdlib.h>
+#include <stdio.h>
 #include <string.h>
 
 
-/** @brief Minimal string class with std::string like behaviour that fulfills the JavaCC
- *  string requirements.
- */
+
 class VhdlString
 {
   public:
@@ -16,88 +25,342 @@ class VhdlString
     {
       init();
     }
-    VhdlString(const VhdlString &other)
+    VhdlString(const VhdlString &other):buffer(0)
     {
-      m_str = (char*)malloc(other.m_len+1);
-      memcpy(m_str,other.m_str,other.m_len);
+      m_str = (wchar_t*)malloc((other.m_len+1)*sizeof(wchar_t));
+      wmemcpy(m_str,other.m_str,other.m_len);
       m_len = other.m_len;
       m_str[m_len]=0;
     }
+
+    VhdlString(const char *s):buffer(0)
+    {
+   	  if(s==0)
+        init();
+     else{
+   	  m_len = strlen(s);
+      m_str=(wchar_t*)malloc((m_len+1)*sizeof(wchar_t));
+      mbstowcs(m_str,s,m_len);
+	  m_str[m_len]=0;
+     }
+    }
+
+
+
+	VhdlString(const wchar_t *s):buffer(0)
+    {
+      m_len = wcslen(s);
+      m_str=(wchar_t*)malloc((m_len+1)*sizeof(wchar_t));
+      wmemcpy(m_str,s,(m_len+1));
+	  m_str[m_len]=0;
+    }
+
+    VhdlString(const wchar_t *s,int size):buffer(0)
+    {
+      m_str = (wchar_t*)malloc((size+1)*sizeof(wchar_t));
+      wmemcpy(m_str,s,size);
+      m_str[size]=0;
+      m_len=size;
+    }
+
      VhdlString &operator=(const VhdlString &other)
     {
       if (this!=&other)
       {
-        free(m_str);
-        m_str = (char*)malloc(other.m_len+1);
-        memcpy(m_str,other.m_str,other.m_len);
+        clear();
+        m_str = (wchar_t*)malloc((other.m_len+1)*sizeof(wchar_t));
+        wmemcpy(m_str,other.m_str,(other.m_len));
         m_len = other.m_len;
         m_str[m_len]=0;
       }
       return *this;
     }
-    VhdlString(const char *s)
+
+	VhdlString &operator=(const char* s)
 	{
+	  clear();
 	  m_len = strlen(s);
-      m_str=(char*)malloc(m_len+1);
-      memcpy(m_str,s,m_len+1);
-    }
-    VhdlString(const char *s,int size)
-    {
-      m_str = (char*)malloc(size+1);
-      memcpy(m_str,s,size);
-      m_str[size]=0;
-      m_len=size;
+      m_str=(wchar_t*)malloc((m_len+1)*sizeof(wchar_t));
+      mbstowcs(m_str,s,m_len);
+	  m_str[m_len]=0;
+	  return *this;
 	}
+
    ~VhdlString()
     {
 		free(m_str);
+		m_str=0;
+
+        free(buffer);
+        buffer=0;
     }
-    VhdlString& append(const char *s,int size)
+
+   VhdlString& prepend(const char *s )
+   {
+	   if(s==0) return *this;
+	   int len=strlen(s);
+	   if(len==0) return *this;
+	   int size=m_len+len+1;
+
+	   m_str = (wchar_t*)realloc(m_str,size*sizeof(wchar_t));
+	   wmemmove(m_str+len,m_str ,m_len);
+       mbstowcs(m_str,s,len);
+	   m_len=size-1;
+	   m_str[m_len]=0;
+
+	   return *this;
+   }
+
+    VhdlString& append(const wchar_t *s,int size)
     {
       int oldlen = m_len;
       m_len+=size+1;
       if (m_len)
       {
-        m_str = (char*)realloc(m_str,m_len);
-        memcpy(m_str+oldlen,s,m_len-oldlen-1);
+  		m_str = (wchar_t*)realloc(m_str,m_len*sizeof(wchar_t));
+   		wmemcpy(m_str+oldlen,s,(m_len-oldlen-1));
 		m_str[m_len-1]=0;
+		m_len--;
       }
       return *this;
     }
-    VhdlString& append(const char *s)
+
+    VhdlString& append(const wchar_t *s)
     {
-      return append(s,strlen(s));
+      return append(s,wcslen(s));
     }
+
     VhdlString& append(const VhdlString &other)
     {
       return append(other.m_str,other.m_len);
     }
+
+
+  VhdlString upper() const
+   {
+	int i=0;
+	VhdlString tmp(m_str);
+	wchar_t c;
+    while (tmp.m_str[i])
+    {
+     c = tmp.m_str[i];
+	  if (islower(c)){
+		tmp.m_str[i]=toupper(c);
+	}
+    i++;
+  }
+  return tmp;
+  }
+
+ int find(const char * s)
+   {
+    VhdlString  tmp(s);
+    wchar_t * pwc;
+    pwc=wcsstr(m_str,tmp.m_str);
+
+	if (pwc!=NULL)
+      return pwc-m_str+1;
+
+	return -1;
+   }
+
+  int findRev(const wchar_t  s)
+   {
+    wchar_t * pwc;
+    pwc=wcsrchr(m_str,s);
+  	if (pwc!=NULL)
+      return pwc-m_str+1;
+
+	return -1;
+   }
+
+
+  VhdlString left( int index )
+  {
+  if (isEmpty())
+  {
+    return  VhdlString();
+  }
+  else if (index>=length())
+  {
+    return  VhdlString(m_str);
+  }
+  else
+  {
+    VhdlString s(L"", index+1 );
+    wmemcpy( s.m_str, m_str, index);
+    return s;
+  }
+ }
+
+ VhdlString right( int len )
+ {
+  if (isEmpty())
+  {
+    return VhdlString();
+  }
+  else
+  {
+    int l = length();
+    if ((int)len>l) len=l;
+    const wchar_t *pos = m_str + (l-len);
+    return VhdlString(pos);
+  }
+ }
+
+
     VhdlString substr(int pos=0,int len=-1)
     {
-      return VhdlString(m_str?m_str+pos:0,len==-1?m_len-pos:m_len);
+      if(len<pos || m_len<len)
+	   return VhdlString (L"");
+
+	  int size=len-pos;
+	  VhdlString tmp(L"",size+1);
+	  copy(tmp.m_str,size,pos);
+      return tmp;
 	}
-    int copy(char *s,int len,int pos=0) const
+
+    int copy(wchar_t *s,int len,int pos=0) const
     {
       if (len==0) return 0;
       if (pos>=m_len) { s[0]=0; return 0; }
       int r=m_len<pos+len ? m_len-pos : len;
-      memcpy(s,m_str+pos,r);
+      wmemcpy(s,m_str+pos,r);
       return r;
     }
-    const char *c_str() const           { return m_str; }
-    const char *data() const            { return m_str; }
+
+
+	void resize(int size)
+	{
+	  if(m_str==0) return;
+	  if(size==0){ clear(); return; }
+	  if(size>=m_len) return;
+
+	  m_str = (wchar_t *)realloc(m_str,(size+1)*sizeof(wchar_t));
+	  m_str[size]='\0';
+      m_len = wcslen(m_str);
+	}
+
+   bool contains(const char * s)
+   {
+     VhdlString tmp(s);
+	   if(wcsstr(m_str,tmp.m_str))
+		 return true;
+	 return false;
+   }
+
+   VhdlString lower() const
+   {
+	int i=0;
+	VhdlString tmp(m_str);
+	wchar_t c;
+    while (tmp.m_str[i])
+    {
+     c = tmp.m_str[i];
+	  if (iswupper(c)){
+		tmp.m_str[i]=tolower(c);
+	}
+    i++;
+  }
+  return tmp;
+  }
+
+    bool stripPrefix(const char * s)
+   {
+
+   int i=find(s);
+   if(i!=1)
+     return false;
+
+    VhdlString tmp(s);
+    int diff=m_len-tmp.m_len;
+
+    if(diff<0)
+        return false;
+
+    wmemcpy(m_str,m_str+tmp.m_len,diff);
+    resize(diff);
+    return true;
+   }
+
+
+
+   const char* data()
+   {
+    if(buffer==0){
+     int len=wcslen(m_str)*sizeof(wchar_t)+1;
+	 buffer=(char*)malloc(len);
+	 buffer[len-1]=0;
+     wcstombs(&buffer[0],m_str,len);
+	}
+	 return buffer;
+   }
+
+	const wchar_t *c_str() const           { return m_str; }
+   // const wchar_t *data() const            { return m_str; }
     int         size() const            { return m_len; }
     int         length() const          { return m_len; }
-    char &      operator[](int i)       { return m_str[i]; }
-    const char &operator[](int i) const { return m_str[i]; }
-    void        clear()                 { free(m_str); init(); }
-    VhdlString  &operator+=(char c)      { char s[2]; s[0]=c; s[1]=0; return append(s); }
-    VhdlString  &operator+=(const char *s) { return append(s); }
+    wchar_t &      operator[](int i)       { return m_str[i]; }
+    const wchar_t &operator[](int i) const { return m_str[i]; }
+    void        clear()                 { free(m_str);free(buffer); init(); }
+	bool isEmpty(){ return size()==0; }
+
+	VhdlString  &operator+=(wchar_t c)      { wchar_t s[2]; s[0]=c; s[1]=0; return append(s); }
+    VhdlString  &operator+=(const wchar_t *s) { return append(s); }
+    VhdlString  &operator+=(const VhdlString &s) { return append(s.c_str()); }
+
+	VhdlString  &operator+=(const char *s)
+    {
+	   VhdlString tmp(s);
+	   return append(tmp.c_str());
+    }
+
+
+ friend VhdlString operator+( const VhdlString &s1, const VhdlString &s2 ){
+	VhdlString tmp(s1);
+    tmp+=s2;
+    return tmp;
+	}
+
+
+ friend VhdlString operator+( const VhdlString &s1, const wchar_t  &s2 ){
+	VhdlString tmp(s1);
+    tmp+=s2;
+    return tmp;
+	}
+
+ friend VhdlString operator+(const wchar_t  *s1, const VhdlString &s2  ){
+	VhdlString tmp(s1);
+	tmp = tmp.append(s2.c_str());
+    return tmp;
+	}
+
+
+ friend VhdlString operator+( const VhdlString &s1, const char  *s2 ){
+	VhdlString tmp(s1);
+    tmp+=s2;
+    return tmp;
+	}
+
+ friend VhdlString operator+(const char *s1, const VhdlString &s2 ){
+	VhdlString tmp(s1);
+    tmp+=s2;
+    return tmp;
+	}
 
   private:
-    void init() { m_str=(char*)calloc(1,1); m_len=0; }
-    char *m_str;
+    void init()
+    {
+         m_str=(wchar_t*)calloc(1,sizeof(wchar_t));
+         m_len=0; buffer=0;
+    }
+    wchar_t *m_str;
     int   m_len;
+    char *buffer;
+
+
 };
 
+
+
 #endif
